/* 
 * $TSUKUBA_Release: Omni XcalableMP Compiler Software Version 0.5 (alpha) $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010 University of Tsukuba
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the file named
 *  COPYRIGHT in the top directory of the Omni Compiler Software release kit.
 *  $
 */
package xcodeml.c.binding;

import xcodeml.c.binding.gen.XbcGccAttributes;

/**
 * Concreate classes implement the interface are follows : 
 * XbcBasicType, XbcPointerType, XbcFunctionType
 * XbcArrayType, XbcStructType, XbcUnionType, XbcEnumType
 */
public interface IXbcType
{
    public String getType();
    
    public void setType(String s);
    
    /**
     * Gets a content of is_volatile attribute.
     *
     * @return a content of is_volatile attribute.
     */
    public String getIsVolatile();

    public void setIsVolatile(String enabled);
    
    /**
     * Gets a content of is_const attribute.
     *
     * @return a content of is_const attribute.
     */
    public String getIsConst();

    public void setIsConst(String enabled);
    
    /**
     * Gets a content of is_restrict attribute.
     *
     * @return a content of is_restrict attribute.
     */
    public String getIsRestrict();

    public void setIsRestrict(String enabled);

    /**
     * Gets the XbcGccAttributes property <b>gccAttributes</b>.
     *
     * @return XbcGccAttributes
     */
    public XbcGccAttributes getGccAttributes();

    public void setGccAttributes(XbcGccAttributes attrs);
}
