/* 
 * $TSUKUBA_Release: Omni XcalableMP Compiler Software Version 0.5 (alpha) $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010 University of Tsukuba
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the file named
 *  COPYRIGHT in the top directory of the Omni Compiler Software release kit.
 *  $
 */
package xcodeml.c.util;

import xcodeml.XmException;
import xcodeml.c.binding.gen.XbcLonglongConstant;
import xcodeml.c.decompile.XcConstObj;
import xcodeml.c.type.XcBaseTypeEnum;
import xcodeml.util.XmBindingException;
import xcodeml.util.XmStringUtil;

public class XmcBindingUtil
{
    public static XcConstObj.LongLongConst createLongLongConst(XbcLonglongConstant visitable)
    {
        String text = XmStringUtil.trim(visitable.getContent());
        if(text == null)
            throw new XmBindingException(visitable, "invalid constant value");
        String[] values = text.split(" ");
        if(values.length != 2)
            throw new XmBindingException(visitable, "invalid constant value");

        XcBaseTypeEnum btEnum;
        String typeId = XmStringUtil.trim(visitable.getType());
        if(typeId == null)
            btEnum = XcBaseTypeEnum.LONGLONG;
        else
            btEnum = XcBaseTypeEnum.getByXcode(typeId);

        if(btEnum == null)
            throw new XmBindingException(visitable, "invalid type '" + typeId + "' as long long constant");
        
        XcConstObj.LongLongConst obj;

        try {
            obj = new XcConstObj.LongLongConst(values[0], values[1], btEnum);
        } catch(XmException e) {
            throw new XmBindingException(visitable, e.getMessage());
        }
        
        return obj;
    }
}
