/* 
 * $TSUKUBA_Release: Omni XcalableMP Compiler Software Version 0.5 (alpha) $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010 University of Tsukuba
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the file named
 *  COPYRIGHT in the top directory of the Omni Compiler Software release kit.
 *  $
 */
package xcodeml.c.util;

import xcodeml.c.type.XcIntegerType;
import xcodeml.c.type.XcPointerType;

/**
 * Utilities of XmOject represents type.
 */
public class XmcTypeUtil
{
    private XmcTypeUtil()
    {
    }

    /**
     * Creates XmObject represent type 'const int * const'
     *
     * @return internal object represent 'const int * const' type.
     */
    public static XcPointerType createConstCharConstPointer()
    {
        XcPointerType ptr = new XcPointerType();
        ptr.setIsConst(true);
        XcIntegerType.Char chr = new XcIntegerType.Char();
        chr.setIsConst(true);
        ptr.setRefType(chr);
        return ptr;
    }
}
