/* 
 * $TSUKUBA_Release: Omni XcalableMP Compiler Software Version 0.5 (alpha) $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010 University of Tsukuba
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the file named
 *  COPYRIGHT in the top directory of the Omni Compiler Software release kit.
 *  $
 */
package xcodeml.util;

import java.util.Iterator;
import java.util.ArrayList;

import xcodeml.XmNode;

public class XmNodeImpl implements XmNode
{
    private String name;
    private ArrayList<XmNodeImpl> children;
    private XmNodeImpl parent;

    public XmNodeImpl(String name)
    {
        this.name = name;
        children = new ArrayList<XmNodeImpl>();
        parent = null;
    }

    public String getName()
    {
        return name;
    }

    public void addChild(XmNode n)
    {
        n.setParent(this);
        children.add((XmNodeImpl)n);
    }

    @Override
    public XmNode[] getChildren()
    {
        XmNode[] a = new XmNode[children.size()];
        return (XmNode[])children.toArray(a);
    }

    @Override
    public XmNode getParent()
    {
        return parent;
    }

    @Override
    public void setParent(XmNode n)
    {
        this.parent = (XmNodeImpl)n;
    }

    @Override
    public Iterator<XmNode> iterator()
    {
        return new XmNodePreOrderIterator(this);
    }

}
