/* 
 * $TSUKUBA_Release: Omni XcalableMP Compiler Software Version 0.5 (alpha) $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010 University of Tsukuba
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the file named
 *  COPYRIGHT in the top directory of the Omni Compiler Software release kit.
 *  $
 */
package xcodeml.binding;

/**
 * Represents element which has lineno and file attribute.
 */
public interface IXbLineNo
{
    /**
     * Gets a line number of original statement/expression/declaration in source code.
     *
     * @return line number description.
     */
    public String getLineno();

    public void setLineno(String lineno);

    /**
     * Gets a raw line number of the original statement/expression/declaration in pre processed source code.
     *
     * @return line number description.
     */
    public String getRawlineno();

    public void setRawlineno(String rawlineno);

    /**
     * Gets file name of the original statement/expression/declaration described.
     *
     * @return file name
     */
    public String getFile();

    public void setFile(String file);
}
