/* 
 * $TSUKUBA_Release: Omni XcalableMP Compiler Software Version 0.5 (alpha) $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010 University of Tsukuba
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the file named
 *  COPYRIGHT in the top directory of the Omni Compiler Software release kit.
 *  $
 */
package xcodeml.binding;

import java.io.IOException;
import java.io.Reader;
import java.io.Writer;

import javax.xml.parsers.ParserConfigurationException;

import org.xml.sax.SAXException;

/**
 * Represents XML element.
 */
public interface IXmlElement
{
    /**
     * Setup by reader.
     */
    public void setup(Reader reader) throws IOException, SAXException, ParserConfigurationException;

    /**
     * Makes an XML text representation.
     *
     * @param buffer output
     */
    public void makeTextElement(StringBuffer buffer);

    /**
     * Makes an XML text representation.
     *
     * @param buffer output
     * @exception IOException
     */
    public void makeTextElement(Writer buffer) throws IOException;
}
