/* 
 * $TSUKUBA_Release: Omni XcalableMP Compiler Software Version 0.5 (alpha) $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010 University of Tsukuba
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the file named
 *  COPYRIGHT in the top directory of the Omni Compiler Software release kit.
 *  $
 */
package xcodeml.util;

import xcodeml.XmObj;

/**
 * The matcher execute mathing about object's interfaces.
 */
public class XmObjInterfaceMatcher implements XmObjMatcher
{
    private Class<?> cls;

    /**
     * Creates XmObjInterfaceMatcher.
     *
     * @param name class name to match wich.
     */
    public XmObjInterfaceMatcher(String name)
    {
        try {
            cls = Class.forName(name);
        } catch(Exception e) {
            cls = null;
        }
    }

    /**
     * Creates XmObjClassMatcher
     *
     * @param c class to match wich.
     */
    public XmObjInterfaceMatcher(Class<?> c)
    {
        this.cls = c;
    }

    @Override
    public boolean match(XmObj n)
    {
        if(n == null) {
            return false;
        } else {
            Class<?> c = n.getClass();
            do {
                for(Class<?> i : c.getInterfaces()) {
                    if(i.equals(cls)) {
                        return true;
                    }
                }
                c = c.getSuperclass();
            } while(!c.equals(Object.class));
            return false;
        }
    }

}
