/* 
 * $TSUKUBA_Release: Omni XcalableMP Compiler Software Version 0.5 (alpha) $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010 University of Tsukuba
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the file named
 *  COPYRIGHT in the top directory of the Omni Compiler Software release kit.
 *  $
 */
package exc.block;

/**
 * super class for Block iterator
 */
public abstract class BlockIterator
{
    Block currentBlock;

    /** constructor with block */
    public BlockIterator(Block b)
    {
        currentBlock = b; // set defaults
    }

    public BlockIterator(BlockList body)
    {
        // nothing
    }

    public abstract void init();

    public abstract void init(Block b);

    public abstract void next();

    public abstract boolean end();

    public abstract int size();

    /** Return the current block */
    public Block getBlock()
    {
        return currentBlock;
    }

    /* + replace the current block with Block b */
    public void setBlock(Block b)
    {
        currentBlock.replace(b);
    }
}
