/* 
 * $TSUKUBA_Release: Omni XcalableMP Compiler Software Version 0.5 (alpha) $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010 University of Tsukuba
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the file named
 *  COPYRIGHT in the top directory of the Omni Compiler Software release kit.
 *  $
 */
package exc.block;

public class backwardStatementIterator implements StatementIterator
{
    private Statement current_statement;

    public backwardStatementIterator(Statement s)
    {
        current_statement = s;
    }

    @Override
    public boolean hasMoreStatement()
    {
        return current_statement != null;
    }

    @Override
    public Statement nextStatement()
    {
        Statement s = current_statement;
        current_statement = current_statement.getPrev();
        return s;
    }

    @Override
    public boolean hasNext()
    {
        return hasMoreStatement();
    }

    @Override
    public Statement next()
    {
        return nextStatement();
    }

    @Override
    public void remove()
    {
        throw new UnsupportedOperationException();
    }
}
