/* 
 * $TSUKUBA_Release: Omni XcalableMP Compiler Software Version 0.5 (alpha) $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010 University of Tsukuba
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the file named
 *  COPYRIGHT in the top directory of the Omni Compiler Software release kit.
 *  $
 */
package exc.object;

/**
 * Represents enum type.
 */
public class EnumType extends Xtype
{
    /** member id list */
    private XobjList moe_list;
    /** original type (to suppress output same type) */
    private Xtype original;

    public EnumType(String id, XobjList moe_list, int typeQualFlags, Xobject gccAttrs)
    {
        super(Xtype.ENUM, id, typeQualFlags, gccAttrs);
        this.moe_list = moe_list;
    }

    @Override
    public boolean isIntegral()
    {
        return true;
    }

    @Override
    public XobjList getMemberList()
    {
        return moe_list;
    }

    @Override
    public Xtype copy(String id)
    {
        EnumType t = new EnumType(
            id, moe_list, getTypeQualFlags(), getGccAttributes());
        t.original = (original != null ? original : this);
        t.tag = tag;
        return t;
    }

    @Override
    public Xtype getOriginal()
    {
    	return original;
    }
}
