/* 
 * $TSUKUBA_Release: Omni XcalableMP Compiler Software Version 0.5 (alpha) $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010 University of Tsukuba
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the file named
 *  COPYRIGHT in the top directory of the Omni Compiler Software release kit.
 *  $
 */
package exc.object;

import xcodeml.ILineNo;

public class LineNo implements ILineNo
{
    String fname;
    int ln;

    static LineNo current_lineno;

    public LineNo(String fname, int ln)
    {
        this.fname = fname.intern();
        this.ln = ln;
    }

    public int lineNo()
    {
        return ln;
    }

    public String fileName()
    {
        return fname;
    }

    @Override
    public String toString()
    {
        return (fname != null ? fname : "") + ":" + ln;
    }
    
    public static LineNo make(String fname, int ln)
    {
        if(current_lineno == null || current_lineno.ln != ln || !current_lineno.fname.equals(fname)) {
            if(fname == null) {
                if(current_lineno == null)
                    fname = "*";
                else
                    fname = current_lineno.fname;
            }
            current_lineno = new LineNo(fname, ln);
        }
        return current_lineno;
    }
}
