/* 
 * $TSUKUBA_Release: Omni XcalableMP Compiler Software Version 0.5 (alpha) $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010 University of Tsukuba
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the file named
 *  COPYRIGHT in the top directory of the Omni Compiler Software release kit.
 *  $
 */
package exc.openmp;

import exc.block.*;
import exc.object.*;

/**
 * OpenMP parallel block
 */
public class OMPparallelBlock extends OMPBlock
{
    public OMPparallelBlock(int narg, BasicBlock setup, BlockList body, Xobject cond)
    {
        super(Xcode.OMP_PARALLEL, setup);
        setNarg(narg);
        setup.setExpr(cond); // set cond exp at end of setup bb.
        setBody(body);
    }

    public BasicBlock setupBasicBlock()
    {
        return getBasicBlock();
    }

    public Xobject getIfExpr()
    {
        return beginBasicBlock().getExpr();
    }
}
