/* 
 * $TSUKUBA_Release: Omni XcalableMP Compiler Software Version 0.5 (alpha) $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010 University of Tsukuba
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the file named
 *  COPYRIGHT in the top directory of the Omni Compiler Software release kit.
 *  $
 */
package exc.util;

import exc.object.XobjList;
import exc.object.Xobject;
import exc.object.XobjectDef;
import exc.object.XobjectDefEnv;

/**
 * Xobject Visitor which visits objects recursively
 */
public class XobjectRecursiveVisitor implements XobjectVisitor
{
    @Override
    public boolean enter(Xobject v)
    {
        if(v instanceof XobjList) {
            for(Xobject a : (XobjList)v) {
                if(a != null && !a.enter(this))
                    return false;
            }
        }
        
        return true;
    }

    @Override
    public boolean enter(XobjectDef v)
    {
        if((v.getDef() != null) && !v.getDef().enter(this)) {
            return false;
        }
        if(v.hasChildren()) {
            for(XobjectDef d : v.getChildren()) {
                if(!d.enter(this))
                    return false;
            }
        }
        return true;
    }

    @Override
    public boolean enter(XobjectDefEnv v)
    {
        for(XobjectDef def : v) {
            if(def != null && !def.enter(this))
                return false;
        }
        return true;
    }
}
