#!/bin/sh

# $TSUKUBA_Release: Omni XcalableMP Compiler Software Version 0.5 (alpha) $
# $TSUKUBA_Copyright:
#  Copyright (C) 2010 University of Tsukuba
#  
#  This software is free software; you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License version
#  2.1 published by the Free Software Foundation.
#  
#  Please check the Copyright and License information in the file named
#  COPYRIGHT in the top directory of the Omni Compiler Software release kit.
#  $

echo aclocal
aclocal --force || exit 1
echo autoheader
autoheader -f || exit 1
echo autoconf
autoconf -f || exit 1

for f in `find . -name Makefile.am -not -path \*/dist/\*`
do
    m=`basename $f .am`
    mm=`dirname $f`/$m
    echo automake $mm
    automake --foreign -f -a -c $mm || exit 1
done

echo delete intermediate files
rm -rf Makefile config.cache config.log config.status autom4te.cache
(cd include;
    rm -rf config.h config.h.in~ stamp-h1)
(cd C-FrontEnd;
    rm -rf src/Makefile)
(cd C-BackEnd;
    rm -rf Makefile ant.properties bin/C_Back)
(cd F-BackEnd;
    rm -rf Makefile ant.properties bin/F_Back)
(cd Driver;
    rm -rf Makefile etc/omc.conf etc/omf.conf \
    etc/java.conf \
    etc/*.xmp etc/*.openmp \
    bin/*.xmp bin/*.openmp \
    bin/oml2x bin/omx2x bin/omx2l \
    bin/ompp bin/omnative bin/omlinker \
    bin/omc2c bin/ompcc bin/omc2x bin/omcx2x bin/omx2c \
    bin/omcpp bin/omcnative bin/omclinker \
    bin/xmpcc)

(cd libxmp;
    rm -rf src/Makefile)
(cd libompc;
    rm -rf src/Makefile)
(cd libtlog;
    rm -rf src/Makefile)
(cd XcodeML-Common;
    rm -rf src/Makefile src/ant.properties)
(cd XcodeML-Exc-Tools;
    rm -rf src/Makefile src/ant.properties)
(cd tests;
    rm -rf C-test/Makefile tiny/Makefile clinkpack/Makefile)

echo 'Now run ./configure'
