/*
 * $TSUKUBA_Release: Omni XcalableMP Compiler Software Version 0.5 (alpha) $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010 University of Tsukuba
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the file named
 *  COPYRIGHT in the top directory of the Omni Compiler Software release kit.
 *  $
 */

#include "xmp_internal.h"

int _XCALABLEMP_world_size;
int _XCALABLEMP_world_rank;
void *_XCALABLEMP_world_nodes;

void _XCALABLEMP_init_world(int *argc, char ***argv) {
  int flag = 0;
  MPI_Initialized(&flag);
  if (!flag) {
    MPI_Init(argc, argv);

    MPI_Comm *comm = _XCALABLEMP_alloc(sizeof(MPI_Comm));
    MPI_Comm_dup(MPI_COMM_WORLD, comm);

    _XCALABLEMP_nodes_t *n = _XCALABLEMP_create_nodes_by_comm(comm);

    _XCALABLEMP_world_size = n->comm_size;
    _XCALABLEMP_world_rank = n->comm_rank;
    _XCALABLEMP_world_nodes = n;

    _XCALABLEMP_push_nodes(n);
  }
}

void _XCALABLEMP_init_world_NULL(void) {
  _XCALABLEMP_init_world(NULL, NULL);
}

void _XCALABLEMP_barrier_WORLD(void) {
  MPI_Barrier(MPI_COMM_WORLD);
}

int _XCALABLEMP_finalize_world(int ret) {
  MPI_Finalize();
  return ret;
}
