/* 
 * $TSUKUBA_Release: Omni XcalableMP Compiler Software Version 0.5 (alpha) $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010 University of Tsukuba
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the file named
 *  COPYRIGHT in the top directory of the Omni Compiler Software release kit.
 *  $
 */
package xcodeml.util;

import java.io.Reader;
import java.io.Writer;

import xcodeml.XmException;
import xcodeml.binding.XmXcodeProgram;

/**
 * The interface for XcodeML decompiler.
 */
public interface XmDecompiler
{
    /**
     * Decompile XcodeProgram document from specified reader.
     * 
     * @param context
     *      decompiler context (optional).
     * @param reader
     *      reader of XcodeProgram document.
     * @param writer
     *      writer of decompiled code.
     * @returns
     *      false if xml validating failed, otherwise true.
     */
    public boolean decompile(XmDecompilerContext context, Reader reader, Writer writer) throws XmException;

    /**
     * Decompile XcodeProgram document from specified XmXcodeProgram object.
     * 
     * @param xmprog
     *      XcodeProgram document object.
     * @param writer
     *      writer of decompiled code.
     */
    public void decompile(XmDecompilerContext context, XmXcodeProgram xmprog, Writer writer) throws XmException;
}
